﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.UltraChart.Resources.Appearance;
using Infragistics.UltraChart.Shared.Styles;
using Infragistics.UltraChart.Core.Layers;
using System.Diagnostics;
using Infragistics.UltraChart.Core.Primitives;

namespace CompositeChart
{
    public partial class Form1 : Form
    {
        private DataTable dt;
        private int count;
        private LineAppearance la;
        private int i;


        public Form1()
        {
            InitializeComponent();
            count = 300;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraChart1.ChartType = ChartType.Composite;


            ChartArea area = new ChartArea();
            this.ultraChart1.CompositeChart.ChartAreas.Add(area);

            dt = new DataTable();
            dt.Columns.Add("Min", typeof(double));
            dt.Columns.Add("MaxStage1", typeof(double));
            dt.Columns.Add("MaxStage2", typeof(double));
            dt.Columns.Add("MaxStage3", typeof(double));
            dt.Columns.Add("Value", typeof(double));
            dt.Columns.Add("Label", typeof(string));

            dt.Rows.Add(0,   5,  0,  0,  1, "Stage1");
            dt.Rows.Add(5,  10,  0,  0, 10, "Stage1");
            dt.Rows.Add(10, 40,  0,  0, 25, "Stage1");
            dt.Rows.Add(30, 25,  0,  0, 40, "Stage1");
            dt.Rows.Add(30, 20,  0,  0, 40, "Stage1");
            dt.Rows.Add(20,  0, 20,  0, 30, "Stage2");
            dt.Rows.Add(15,  0, 25,  0, 25, "Stage2");
            dt.Rows.Add(10,  0, 20,  0, 20, "Stage2");
            dt.Rows.Add(10,  0,  0, 20, 20, "Stage3");
            dt.Rows.Add( 5,  0,  0, 15, 15, "Stage3");



            AxisItem axisX = new AxisItem();
            axisX.DataType = AxisDataType.String;
            axisX.OrientationType = AxisNumber.X_Axis;
            axisX.Labels.ItemFormat = AxisItemLabelFormat.ItemLabel;
            axisX.Labels.ItemFormatString = "<ITEM_LABEL>";
            axisX.SetLabelAxisType = SetLabelAxisType.ContinuousData;
            axisX.Labels.Orientation = TextOrientation.VerticalLeftFacing;
            axisX.ScrollScale.Visible = true;
            axisX.Extent = 120;
            area.Axes.Add(axisX);

            AxisItem axisY = new AxisItem();
            axisY.DataType = AxisDataType.Numeric;
            axisY.OrientationType = AxisNumber.Y_Axis;
            axisY.Extent = 20;
            axisY.Labels.ItemFormatString = "<DATA_VALUE:##.##>";
            axisY.LineColor = Color.Blue;
            area.Axes.Add(axisY);


            ChartLayerAppearance myColumnLayer2 = new ChartLayerAppearance();
            myColumnLayer2.ChartType = ChartType.LineChart;
            myColumnLayer2.ChartArea = area;

            ChartLayerAppearance myColumnLayer = new ChartLayerAppearance();
            myColumnLayer.ChartType = ChartType.StackAreaChart;
            myColumnLayer.ChartArea = area;

            this.ultraChart1.CompositeChart.ChartLayers.Add(myColumnLayer);
            this.ultraChart1.CompositeChart.ChartLayers.Add(myColumnLayer2);

            NumericSeries seriesLine = new NumericSeries();
            seriesLine.DataBind(dt, "Value", "Label");
            seriesLine.PEs.Add(new PaintElement(Color.Red));
            myColumnLayer2.Series.Add(seriesLine);
            ultraChart1.CompositeChart.Series.Add(seriesLine);
            myColumnLayer2.AxisX = axisX;
            myColumnLayer2.AxisY = axisY;

            NumericSeries series1 = new NumericSeries();
            series1.DataBind(dt, "Min", "Label");
            series1.PEs.Add(new PaintElement(Color.Transparent));
            myColumnLayer.Series.Add(series1);
            ultraChart1.CompositeChart.Series.Add(series1);
            myColumnLayer.AxisX = axisX;
            myColumnLayer.AxisY = axisY;

            NumericSeries series2 = new NumericSeries();
            series2.DataBind(dt, "MaxStage1", "Label");
            series2.PEs.Add(new PaintElement(Color.Yellow));
            myColumnLayer.Series.Add(series2);
            ultraChart1.CompositeChart.Series.Add(series2);
            //myColumnLayer.AxisX = axisX;
            //myColumnLayer.AxisY = axisY;

            NumericSeries series3 = new NumericSeries();
            series3.DataBind(dt, "MaxStage2", "Label");
            series3.PEs.Add(new PaintElement(Color.Orange));
            myColumnLayer.Series.Add(series3);
            ultraChart1.CompositeChart.Series.Add(series3);
            //myColumnLayer.AxisX = axisX;
            //myColumnLayer.AxisY = axisY;

            NumericSeries series4 = new NumericSeries();
            series4.DataBind(dt, "MaxStage3", "Label");
            series4.PEs.Add(new PaintElement(Color.Orchid));
            myColumnLayer.Series.Add(series4);
            ultraChart1.CompositeChart.Series.Add(series4);
            //myColumnLayer.AxisX = axisX;
            //myColumnLayer.AxisY = axisY;

        }


        private void ultraButton3_Click(object sender, EventArgs e)
        {
            ultraChart1.SaveTo(@"..\\..\\Test.bmp", System.Drawing.Imaging.ImageFormat.Bmp);
        }

        private void ultraChart1_ChartDrawItem(object sender, Infragistics.UltraChart.Shared.Events.ChartDrawItemEventArgs e)
        {

            if (e.Primitive.GetType() == typeof(Infragistics.UltraChart.Core.Primitives.Box))
            {
                e.Primitive.PE.Fill = Color.White;
            }
        }

    }
}